'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/* eslint-env browser */

var React = require('react');

var _require = require('react-redux'),
    connect = _require.connect;

module.exports = function (mapStateToProps, mapDispatchToProps) {
  return function (WrappedComp) {
    var Connector = function (_React$Component) {
      _inherits(Connector, _React$Component);

      function Connector() {
        _classCallCheck(this, Connector);

        return _possibleConstructorReturn(this, (Connector.__proto__ || Object.getPrototypeOf(Connector)).apply(this, arguments));
      }

      _createClass(Connector, [{
        key: 'componentWillMount',
        value: function componentWillMount() {
          if (typeof window === 'undefined') {
            return;
          }
          var pageTitle = WrappedComp.pageTitle;

          document.title = pageTitle || document.title;
        }
      }, {
        key: 'render',
        value: function render() {
          return React.createElement(WrappedComp, this.props);
        }
      }], [{
        key: 'pageInit',
        value: function pageInit(store, rootSaga) {
          var action = WrappedComp.pageInit instanceof Function ? WrappedComp.pageInit() : {};

          // page service server render
          if (action instanceof Function) {
            var promise = store.runSaga(rootSaga()).done;
            store.dispatch(action());
            return promise;
          }

          console.error('PageInit should return a function');
          return Promise.resolve();
        }
      }]);

      return Connector;
    }(React.Component);

    return connect(mapStateToProps, mapDispatchToProps)(Connector);
  };
};